//#include "system_definitions.h"
#include "definitions.h"
#include "app.h"

extern uint8_t buf[64];
extern uint8_t buf1[64];
uint8_t handle[2];
extern uint32_t dataFlash[128];

extern bool acl_suspned_flag;
extern uint8_t hid_state;
extern bool ConnectSwitch;

void l2cap_connection(void);

void hci_init(void) {

    buf1[0] = 0x03;
    buf1[1] = 0x0c;
    buf1[2] = 0;

    Write_HCI_Command("HCI_CMD_RESET: ");

}

void hci(void) {

    int pdata;
    uint32_t *p; //pointer for flash memory
    static uint8_t host_bt_address[6];
    static uint8_t link_key[22];


    if (buf1[0] == 0x0e && buf1[3] == 0x03 && buf1[4] == 0x0c) {
        buf1[0] = 0x09;
        buf1[1] = 0x10;
        buf1[2] = 0;

        Write_HCI_Command("HCI_CMD_READ_BD_ADDR: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x09 && buf1[4] == 0x10) {

        buf1[0] = 0x13;
        buf1[1] = 0x0c;
        buf1[2] = 0x04;
        buf1[3] = 'y';
        buf1[4] = 't';
        buf1[5] = 's';
        buf1[6] = 0x00;

        Write_HCI_Command("HCI_CMD_LOCAL_NAME: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x13 && buf1[4] == 0x0c) {
        buf1[0] = 0x24;
        buf1[1] = 0x0c;
        buf1[2] = 0x03;
        buf1[3] = 0x04; //joystick
        buf1[4] = 0x05; //joystick
        buf1[5] = 0x00;

        Write_HCI_Command("HCI_CMD_CLASS_DEVICE: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x24 && buf1[4] == 0x0c) {
        buf1[0] = 0x56;
        buf1[1] = 0x0c;
        buf1[2] = 0x01;
        buf1[3] = 0x01;

        Write_HCI_Command("HCI_CMD_SIMPLE_PAIR: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x56 && buf1[4] == 0x0c) {
        buf1[0] = 0x01;
        buf1[1] = 0x0c;
        buf1[2] = 0x08;
        buf1[3] = 0xff;
        buf1[4] = 0xff;
        buf1[5] = 0xff;
        buf1[6] = 0xff;
        buf1[7] = 0xff;
        buf1[8] = 0x1f;
        buf1[9] = 0xff;
        buf1[10] = 0x00;

        Write_HCI_Command("HCI_CMD_EVENT_MASK: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x01 && buf1[4] == 0x0c) {
        buf1[0] = 0x1a;
        buf1[1] = 0x0c;
        buf1[2] = 0x01;
        buf1[3] = 0x03;

        Write_HCI_Command("HCI_CMD_SCAN_ENABLE: ");

    } else if (buf1[0] == 0x0e && buf1[3] == 0x1a && buf1[4] == 0x0c && ConnectSwitch == true && hid_state == 0) {
        //hid_flag==0 is needed for getting rid of scan disable

        //get storde BD_address of PC
        p = (uint32_t *) KVA0_TO_KVA1(PROGRAM_FLASH_BASE_ADDRESS);
        for (pdata = 0; pdata < 6; pdata++)
            buf1[pdata + 3] = (uint8_t) p[pdata];

        buf1[0] = 0x05;
        buf1[1] = 0x04;
        buf1[2] = 0x0d;
        //	buf1[3]//******************************************
        //	buf1[4]//bd_address (6 octets) of the PIC bluetooth
        //	buf1[5]//
        //	buf1[6]//
        //	buf1[7]//
        //	buf1[8]//******************************************
        buf1[9] = 0x10;
        buf1[10] = 0x00;
        buf1[11] = 0x00;
        buf1[12] = 0x00;
        buf1[13] = 0xc2;
        buf1[14] = 0xb0;
        buf1[15] = 0x00;

        Write_HCI_Command("HCI_CMD_CREATE_CONNECTION: ");

    } else if (buf1[0] == 0x03 && buf1[2] == 0x00 && ConnectSwitch == true) {
        handle[0] = buf1[3];
        handle[1] = buf1[4] + 0x20;

        buf1[0] = 0x11;
        buf1[1] = 0x04;
        buf1[2] = 0x02;
        //	buf1[3]=0x06;
        //	buf1[4]=0x06;

        Write_HCI_Command("HCI_AUTH_REQ: ");

    } else if (buf1[0] == 0x03 && buf1[2] == 0x00 && ConnectSwitch == false) {

        Read_ACL_Command();

    } else if (buf1[0] == 0x03 && buf1[2] != 0x00 && ConnectSwitch == true) {
        //try to connect again

        //get storde BD_address of PC
        p = (uint32_t *) KVA0_TO_KVA1(PROGRAM_FLASH_BASE_ADDRESS);
        for (pdata = 0; pdata < 6; pdata++)
            buf1[pdata + 3] = (uint8_t) p[pdata];

        buf1[0] = 0x05;
        buf1[1] = 0x04;
        buf1[2] = 0x0d;
        //	buf1[3]//******************************************
        //	buf1[4]//bd_address (6 octets) of the PIC bluetooth
        //	buf1[5]//
        //	buf1[6]//
        //	buf1[7]//
        //	buf1[8]//******************************************
        buf1[9] = 0x10;
        buf1[10] = 0x00;
        buf1[11] = 0x00;
        buf1[12] = 0x00;
        buf1[13] = 0xc2;
        buf1[14] = 0xb0;
        buf1[15] = 0x00;

        Write_HCI_Command("HCI_CMD_CREATE_CONNECTION_AGAIN: ");

    } else if (buf1[0] == 0x04) {
        for (pdata = 0; pdata < 6; pdata++) host_bt_address[pdata] = buf1[pdata + 2];

        buf1[8] = buf1[7]; //copy address
        buf1[7] = buf1[6];
        buf1[6] = buf1[5];
        buf1[5] = buf1[4];
        buf1[4] = buf1[3];
        buf1[3] = buf1[2];
        buf1[0] = 0x09;
        buf1[1] = 0x04;
        buf1[2] = 0x07;
        buf1[9] = 0x01; //role

        Write_HCI_Command("HCI_CMD_CONNECTION_ACCEPT: ");

    } else if (buf1[0] == 0x05) {
        buf1[0] = 0x06;
        buf1[1] = 0x04;
        buf1[2] = 0x03;
        buf1[3] = handle[0];
        buf1[4] = handle[1] - 0x20;
        buf1[5] = 0x13;

        LED_Off();
                
        Write_HCI_Command("HCI_CMD_DISCONNECT_REQ: ");

    } else if (buf1[0] == 0x06) {
        buf1[0] = 0x13;
        buf1[1] = 0x04;
        buf1[2] = 0x03;
        buf1[3] = handle[0];
        buf1[4] = handle[1] - 0x20;
        buf1[5] = 0x01;

        Write_HCI_Command("HCI_SET_ENCRYPT: ");

    } else if (buf1[0] == 0x08 && ConnectSwitch == true) {
        l2cap_connection();
    } else if (buf1[0] == 0x13) {

        if (acl_suspned_flag == true) {
            acl_suspned_flag = false;
            l2cap_sdp_hid();
        } else {
            Read_ACL_Command();
        }

    } else if (buf1[0] == 0x17) {
        buf1[0] = 0x0b;
        buf1[1] = 0x04;
        buf1[2] = 0x16;

        if (ConnectSwitch == false) {
            for (pdata = 0; pdata < 22; pdata++)
                buf1[pdata + 3] = link_key[pdata];
        } else {
            p = (uint32_t *) KVA0_TO_KVA1(PROGRAM_FLASH_BASE_ADDRESS);
            for (pdata = 0; pdata < 22; pdata++)
                buf1[pdata + 3] = (uint8_t) p[pdata];
        }

        Write_HCI_Command("HCI_LINK_KEY_REP: ");

    } else if (buf1[0] == 0x18) {

        //  Write a datum to PROGRAM_FLASH
        for (pdata = 0; pdata < 22; pdata++) {
            link_key[pdata] = buf1[pdata + 2];
            NVM_WordWrite(buf1[pdata + 2], PROGRAM_FLASH_BASE_ADDRESS + 4 * pdata );
            while(NVM_IsBusy() == true);
        }

    } else if (buf1[0] == 0x31) {
        buf1[0] = 0x2b;
        buf1[1] = 0x04;
        buf1[2] = 0x09;

        for (pdata = 0; pdata < 6; pdata++) buf1[3 + pdata] = host_bt_address[pdata];
        buf1[9] = 0x03;
        buf1[10] = 0x00;
        buf1[11] = 0x00;

        Write_HCI_Command("HCI_IOC_REPLY: ");

    } else if (buf1[0] == 0x33) {
        buf1[0] = 0x2c;
        buf1[1] = 0x04;
        buf1[2] = 0x06;

        for (pdata = 0; pdata < 6; pdata++) buf1[3 + pdata] = host_bt_address[pdata];

        Write_HCI_Command("HCI_CONF_REPLY: ");

    } else if (buf1[0] == 0x0e && hid_state == 0xff) {//scan disable sent
        UART3_WriteString("hid \r\n");

        LED_On();
        
        Read_ACL_Command();
        hid();
    }
}

