//#include "system_definitions.h"
#include "definitions.h"
extern uint8_t buf[64];
extern uint8_t buf1[64];

extern uint8_t handle[2];

uint8_t src_cid[2];
uint8_t dst_cid[2];
uint8_t src_cid1[2];
uint8_t dst_cid1[2];

extern uint8_t l2cap_pass;
extern uint8_t hid_state;
extern bool acl_suspned_flag;

extern bool ConnectSwitch;

//********************************************************************************
//********************************************************************************
//L2CAP layer
//********************************************************************************
//********************************************************************************

void l2cap_connection(void) {

    handle[0] = buf1[3];
    handle[1] = buf1[4] + 0x20;

    buf[0] = handle[0];
    buf[1] = handle[1];
    buf[2] = 0x0c;
    buf[3] = 0x00;
    buf[4] = 0x08;
    buf[5] = 0x00;
    buf[6] = 0x01;
    buf[7] = 0x00;
    buf[8] = 0x02;//
    if (hid_state == 0x13) buf[9] = 4;
    else buf[9] = 0x01;
    buf[10] = 0x04;
    buf[11] = 0x00;
    if (hid_state == 0x13) buf[12] = 0x13;
    else buf[12] = 0x11;
    buf[13] = 0x00;
    if (hid_state == 0x13) buf[14] = 0x41;
    else buf[14] = 0x40;
    buf[15] = 0x00;

    if (hid_state != 0x13) hid_state = 0x11;

    Write_ACL_Command("L2CAP_CON_REQ_TO: \r\n      ");

}

void l2cap(void) {//FIRST CONNECTION

    if (buf[8] == 0x02) {

        l2cap_pass = 0;

        handle[0] = buf[0];
        handle[1] = buf[1];
        if (buf[12] == 0x11) hid_state = 0x11;
        if (buf[12] == 0x13) hid_state = 0x13;
        buf[2] = 0x10;
        buf[4] = 0x0c;
        buf[8] = 0x03; //
        buf[10] = 0x08;
        buf[12] = buf[14] + 4; //dst_cid (PIC)
        buf[13] = buf[15]; //
        buf[16] = 0x00; //result
        buf[17] = 0x00; //
        buf[18] = 0x00; //statis
        buf[19] = 0x00; //

        src_cid[0] = buf[14];
        src_cid[1] = buf[15];

        if (hid_state == 0x11) {
            src_cid1[0] = buf[14];
            src_cid1[1] = buf[15];
        }

        Write_ACL_Command("L2CAP_CONFIG_REQ:\r\n      ");

    } else if (buf[8] == 0x03) {//SECOND CONNECTION OR LATTER

        l2cap_pass = 0;

        src_cid[0] = buf[14];
        src_cid[1] = buf[15];
        dst_cid[0] = buf[12];
        dst_cid[1] = buf[13];
        Read_ACL_Command();

    } else if (buf[8] == 0x04 && ConnectSwitch == false) {//FIRST CONNECTION

        if (l2cap_pass != 0) return;
        buf[18] = 0x01; //buf[16];//option
        buf[19] = 0x02; //buf[17];//
        buf[20] = 0x00; //buf[18];//
        buf[21] = 0x01; //buf[19];//
        buf[2] = 0x12;
        buf[4] = 0x0e;
        buf[8] = 0x05; //
        buf[10] = 0x0a;
        buf[12] = src_cid[0];
        buf[13] = src_cid[1];
        buf[16] = 0x00; //result
        buf[17] = 0x00; //

        acl_suspned_flag = true;
        l2cap_pass = 1;
        Write_ACL_Command("L2CAP_CONFIG_RESP:\r\n      ");

    } else if (l2cap_pass == 1) {

        l2cap_pass = 0;

        buf[16] = 0x01; //buf[18];//option
        buf[17] = 0x02; //buf[19];//
        buf[18] = 0x00; //buf[20];//
        buf[19] = 0x01; //buf[21];//
        buf[2] = 0x10;
        buf[4] = 0x0c;
        buf[8] = 0x04; //
        buf[10] = 0x08;
        buf[12] = src_cid[0];
        buf[13] = src_cid[1];
        buf[14] = 0x00; //result
        buf[15] = 0x00; //

        Write_ACL_Command("L2CAP_CONFIG_REQ_HOST:\r\n      ");

    } else if (buf[8] == 0x04 && ConnectSwitch == true) {//SECOND OR LATTER CONNECTIONS

        buf[2] = 0x0e;
        buf[4] = 0x0a;
        buf[8] = 0x05;//
        buf[10] = 0x06;
        buf[12] = dst_cid[0];
        buf[13] = dst_cid[1];
        buf[14] = 0x00; //result
        buf[15] = 0x00; //
        buf[16] = 0x00; //
        buf[17] = 0x00; //

        acl_suspned_flag = true;
        l2cap_pass = 2;
        Write_ACL_Command("L2CAP_CONFIG_REQ_FROM:\r\n      ");

    } else if (l2cap_pass == 2) {

        l2cap_pass = 0;
        buf[2] = 0x0c;
        buf[4] = 0x08;
        buf[8] = 0x04;//
        buf[9] = 0x02;
        buf[10] = 0x04;
        buf[12] = dst_cid[0];
        buf[13] = dst_cid[1];
        buf[14] = 0x00; //result
        buf[15] = 0x00; //

        Write_ACL_Command("L2CAP_CONFIG_REQ_HOST_TO:\r\n      ");

    } else if (buf[8] == 0x05 && ConnectSwitch == false) {

        Read_ACL_Command();

    } else if (buf[8] == 0x05 && ConnectSwitch == true) {

        if (hid_state == 0x11) {
            hid_state = 0x13;
            handle[0] = buf1[3];
            handle[1] = buf1[4] + 0x20;

            buf[0] = handle[0];
            buf[1] = handle[1];
            buf[2] = 0x0c;
            buf[3] = 0x00;
            buf[4] = 0x08;
            buf[5] = 0x00;
            buf[6] = 0x01;
            buf[7] = 0x00;
            buf[8] = 0x02;//
            if (hid_state == 0x13) buf[9] = 4;
            else buf[9] = 0x01;
            buf[10] = 0x04;
            buf[11] = 0x00;
            if (hid_state == 0x13) buf[12] = 0x13;
            else buf[12] = 0x11;
            buf[13] = 0x00;
            if (hid_state == 0x13) buf[14] = 0x41;
            else buf[14] = 0x40;
            buf[15] = 0x00;

            if (hid_state != 0x13) hid_state = 0x11;

            Write_ACL_Command("L2CAP_CON_REQ_TO: \r\n      ");

        } else if (hid_state == 0x13) {
            Read_ACL_Command();
        }
    } else if (buf[8] == 0x06) {
        buf[8] = 0x07;
        Write_ACL_Command("L2CAP_DISCONNECTION:\r\n      ");
    }
}


